package com.hssx.bms.until;

import net.lingala.zip4j.core.ZipFile;
import net.lingala.zip4j.exception.ZipException;
import net.lingala.zip4j.model.FileHeader;

import java.util.List;
import java.util.Scanner;

/**
 * Author: 吴涛涛 cuiyi@itany.com
 * Date : 2019 - 10 - 18 11:15
 * Description:<描述>
 * Version: 1.0
 */
public class Zip4jUtil {
    public static void main(String[] args) throws ZipException {
        Unzip4j1("D:\\666.zip","D:\\666");
    }

    // 解压方法2
    public static void Unzip4j1(String zipFile,String folderPath) throws ZipException {
        long startTime = System.currentTimeMillis();
        ZipFile zipFile2 = new ZipFile(zipFile);
        //设置编码格式
        zipFile2.setFileNameCharset("GBK");
        if (!zipFile2.isValidZipFile()) {
            throw new ZipException("文件不合法或不存在");
        }
        //检查是否需要密码
//        checkEncrypted(zipFile2);
        List<FileHeader> fileHeaderList = zipFile2.getFileHeaders();
        for (int i = 0; i < fileHeaderList.size(); i++) {
            FileHeader fileHeader = fileHeaderList.get(i);
            zipFile2.extractFile(fileHeader, folderPath);
        }
        System.out.println("解压成功！");
        long endTime = System.currentTimeMillis();
        System.out.println("耗时：" + (endTime - startTime) + "ms");
    }

    //检测密码
    private void checkEncrypted(ZipFile zip) throws ZipException {
        Scanner in=new Scanner(System.in);
        if (zip.isEncrypted()) {
            System.out.println("文件"+zip.getFile().getName()+"有密码！");
            System.out.println("请输入密码：");
            zip.setPassword(in.next().trim());
        }
        in.close();
    }
}
